SystemOrganization addCategory: #'SlotExtras-Class'!
SystemOrganization addCategory: #'SlotExtras-Transformation'!
SystemOrganization addCategory: #'SlotExtras-ClassBuilder'!
SystemOrganization addCategory: #'SlotExtras-Slot'!
SystemOrganization addCategory: #'SlotExtras-Slot-Modifier'!
SystemOrganization addCategory: #'SlotExtras-Slot-Test'!
SystemOrganization addCategory: #'SlotExtras-Traits'!
SystemOrganization addCategory: #'SlotExtras-Traits-Test'!
SystemOrganization addCategory: #'SlotExtras-Error'!
SystemOrganization addCategory: #'SlotExtras-LayoutBuilder'!
SystemOrganization addCategory: #'SlotExtras-Layout'!

Trait named: #TStatefulTest
	uses: {}
	category: 'SlotExtras-Traits-Test'!

!TStatefulTest methodsFor: 'some messages' stamp: 'ToonVerwaest 4/4/2011 13:58'!
aMethod
	super test.
	^ tfirst + tsecond! !

!TStatefulTest methodsFor: 'some messages' stamp: 'ToonVerwaest 4/4/2011 13:25'!
tfirst: aValue
	tfirst := aValue! !

!TStatefulTest methodsFor: 'some messages' stamp: 'ToonVerwaest 4/4/2011 13:42'!
tsecond: aValue
	tsecond := aValue! !

LayoutAbstractScope subclass: #LayoutForkScope
	instanceVariableNames: 'parentScope sideScopes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Layout'!

!LayoutForkScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:42'!
allSlotsDo: aBlock
	^ parentScope allSlotsDo: aBlock! !

!LayoutForkScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	^ parentScope allSlotsReverseDo: aBlock! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:08'!
allVisibleSlots
	^ parentScope allVisibleSlots! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:22'!
fieldSize
	| size |
	size := parentScope fieldSize.
	sideScopes do: [ :aScope | size := size + aScope fieldSize ].
	^ size! !

!LayoutForkScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 18:22'!
flatten
	| result |
	result := parentScope flatten.
	sideScopes do: [ :aScope | result addAll: aScope flatten ].
	^ result! !

!LayoutForkScope methodsFor: 'forking' stamp: 'CamilloBruni 4/4/2011 18:16'!
forkScope: aScope
	| fieldIndex |
	fieldIndex := self firstFieldIndex.
	aScope allSlotsDo: [ :aSlot |
		aSlot index: fieldIndex.
		fieldIndex := fieldIndex + aSlot size ].
	sideScopes := sideScopes copyWith: aScope.! !

!LayoutForkScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:42'!
hasFields
	^ parentScope hasFields! !

!LayoutForkScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 18:24'!
hasSlots
	parentScope hasSlots ifTrue: [ ^ true ].
	sideScopes do: [ :aScope | aScope hasSlots ifTrue: [ ^ true ]].
	^ false! !

!LayoutForkScope methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/2/2011 18:26'!
initialize
	sideScopes := {}! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:27'!
ownFieldSize
	self flag: 'might be rather the size of the sidescopes...'.
	^ 0! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:53'!
parentScope: anObject
	parentScope := anObject! !

!LayoutForkScope methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 18:30'!
postCopy
	| newSideScopes |
	parentScope := parentScope copy.
	newSideScopes := Array new: sideScopes size.
 	sideScopes withIndexDo: [ :aScope :anIndex | newSideScopes at: anIndex put: aScope copy ].
	sideScopes := newSideScopes.! !

!LayoutForkScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:42'!
printSlotDefinitionOn: aStream
	^ parentScope printSlotDefinitionOn: aStream! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:53'!
sideScopes
	^ sideScopes! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:53'!
sideScopes: anObject
	sideScopes := anObject! !

!LayoutForkScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:58'!
visibleSlotNames
	^ {}! !

!LayoutForkScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:32'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

LayoutAbstractScope subclass: #SlotAddingScope
	instanceVariableNames: 'parentScope slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Layout'!

SlotAddingScope subclass: #BitFieldScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Layout'!

!BitFieldScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 22:01'!
bitField
	^ slots first! !

!BitFieldScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:10'!
initialize
	super initialize.
	slots := Array with: (BitFieldHolderSlot new)! !

!BitFieldScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 21:56'!
isFull
	^ self bitField isFull! !

SlotAddingScope subclass: #PropertyScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Layout'!

!PropertyScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:09'!
initialize
	super initialize.
	slots := Array with: (PropertyHolderSlot new)! !

!PropertyScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 22:01'!
propertyHolder
	^ slots first! !

!SlotAddingScope class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:43'!
withParent: aScope
	^ self new
		parentScope: aScope;
		yourself! !

!SlotAddingScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:07'!
allSlotsDo: aBlock
	parentScope allSlotsDo: aBlock.
	slots do: aBlock.! !

!SlotAddingScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:07'!
allSlotsReverseDo: aBlock
	slots reverseDo: aBlock.
	parentScope allSlotsReverseDo: aBlock.! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:07'!
allVisibleSlots
	| result |
	result := parentScope allVisibleSlots.
	slots do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot ]].
	^ result! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:27'!
fieldSize
	^ parentScope fieldSize + self ownFieldSize! !

!SlotAddingScope methodsFor: 'flattening' stamp: 'CamilloBruni 4/4/2011 18:07'!
flatten
	| result |
	result := parentScope flatten.
	result addAll: slots.
	^ result! !

!SlotAddingScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 18:07'!
hasFields
	slots do: [ :slot | 
		slot size > 0 
			ifTrue: [ ^ true ]].
	^ parentScope hasFields! !

!SlotAddingScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 18:07'!
hasSlots
	slots size > 0 
		ifTrue: [ ^ true ].
	^ parentScope hasSlots! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:28'!
ownFieldSize
	| result |
	result := 0.
	slots do: [ :slot | 
		result := result + slot size ].
	^ result! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 22:01'!
parentScope: aScope
	| fieldIndex |
	parentScope := aScope.
	fieldIndex := aScope firstFieldIndex.
	slots do: [ :slot|
		slot index: fieldIndex.
		fieldIndex := fieldIndex + slot size].! !

!SlotAddingScope methodsFor: 'copying' stamp: 'CamilloBruni 4/4/2011 18:07'!
postCopy
	parentScope := parentScope copy.
	1 to: slots size do: [ :index | 
		self at: index put: (slots at: index) copy ]! !

!SlotAddingScope methodsFor: 'printing' stamp: 'CamilloBruni 4/4/2011 18:12'!
printSlotDefinitionOn: aStream

	^ parentScope printSlotDefinitionOn: aStream! !

!SlotAddingScope methodsFor: 'reshaping' stamp: 'CamilloBruni 4/4/2011 18:11'!
rebase: originalLayout to: newLayout
	self halt.
	! !

!SlotAddingScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:08'!
visibleSlotNames
	| result |
	result := OrderedCollection new.
	slots do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot name ]].
	^ result asArray! !

!SlotAddingScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:33'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

Error subclass: #AccessError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

AccessError subclass: #ReadAccessError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

AccessError subclass: #WriteAccessError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

Error subclass: #InvalidArgument
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

!InvalidArgument class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 00:41'!
argument: aValue
	^ self new
		argument: aValue;
		yourself ! !

!InvalidArgument methodsFor: 'accessing' stamp: 'CamilloBruni 3/25/2011 00:41'!
argument
	^ argument! !

!InvalidArgument methodsFor: 'accessing' stamp: 'CamilloBruni 3/25/2011 00:41'!
argument: anObject
	argument := anObject! !

InvalidArgument subclass: #SlotConditionFailed
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

!SlotConditionFailed class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 00:42'!
argument: aValue slot: aSlot
	^ (self new)
		argument: aValue;
		slot: aSlot;
		yourself! !

!SlotConditionFailed methodsFor: 'accessing' stamp: 'CamilloBruni 3/25/2011 17:14'!
slot
	^ slot! !

!SlotConditionFailed methodsFor: 'accessing' stamp: 'CamilloBruni 3/25/2011 17:14'!
slot: anObject
	slot := anObject! !

Error subclass: #InvalidLayout
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

!InvalidLayout methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 17:17'!
reference
	^ reference! !

!InvalidLayout methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 17:17'!
reference: anObject
	reference := anObject! !

InvalidLayout subclass: #LayoutNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

LayoutNotFound subclass: #BitFieldLayoutNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

!BitFieldLayoutNotFound methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:49'!
messageText
	^ 'BitFieldLayout not found in ', self reference name.! !

LayoutNotFound subclass: #PropertyLayoutNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Error'!

!PropertyLayoutNotFound methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 17:22'!
messageText
	^ 'PropertyLayout not found in ', self reference name.! !

IRVisitor subclass: #MethodFieldUpdater
	instanceVariableNames: 'methodModification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-ClassBuilder'!

!MethodFieldUpdater methodsFor: 'private' stamp: 'CamilloBruni 3/28/2011 18:43'!
decompile: aMethod

	^ OCBytecodeDecompiler new decompile: aMethod! !

!MethodFieldUpdater methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:00'!
recompileMethod: method withSelector: selector to: aClass
	| ir newMethod |
	ir := self decompile: method.
	[ ir accept: self.
	newMethod := ir compiledMethodWith: method trailer.
	newMethod selector: selector.
	newMethod methodClass: aClass.
	aClass methodDict at: selector put: newMethod ] on: Exception do:
		[ :ex | " we didn't have enough data to bytecode recompile, bail out and fully recompile "
			aClass methodDict at: selector put: method.
			aClass recompile: selector
		]! !

!MethodFieldUpdater methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 19:51'!
transformAll: methodDict using: aMethodModification to: aClass
	methodModification := aMethodModification.
	methodDict keysAndValuesDo: [ :selector :method |
		self recompileMethod: method withSelector: selector to: aClass ]! !

!MethodFieldUpdater methodsFor: 'visiting' stamp: 'ToonVerwaest 3/28/2011 17:52'!
visitInstVarAccess: anInstVarAccess
	(methodModification modificationAt: anInstVarAccess number)
		applyToIR: anInstVarAccess! !

!MethodFieldUpdater methodsFor: 'visiting' stamp: 'ToonVerwaest 3/28/2011 20:01'!
visitPushLiteral: aPushLiteral
	(aPushLiteral literal isKindOf: AbstractFieldModification)
		ifTrue: [
			aPushLiteral literal
				rewriteIR: aPushLiteral
				usingModification: methodModification ]! !

!RBMethodNode methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/23/2011 15:16'!
schematicTempNamesString
	^ nil! !

!AbstractFieldModification methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 3/28/2011 17:52'!
applyToIR: aFieldAccess! !

!AbstractFieldModification methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 3/28/2011 18:29'!
rewriteIR: aNode usingModification: aMethodModification! !

UndefinedObject subclass: #UninitializedField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!UninitializedField class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:22'!
new
	^ self basicNew! !

!UninitializedField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:26'!
printOn: aStream 
	aStream nextPutAll: 'not initialized'! !

!UninitializedField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:26'!
storeOn: aStream 
	aStream nextPutAll: 'not initialized'! !

!RemovedField methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 3/28/2011 18:07'!
applyToIR: aFieldAccess
	| nodes |
	nodes := aFieldAccess isRead
				ifTrue: [ self buildInvalidReadIRNodes ]
				ifFalse: [ self buildInvalidWriteIRNodes ].
	aFieldAccess sequence
		replaceNode: aFieldAccess
		withNodes: nodes! !

!RemovedField methodsFor: '*SlotExtras-recompiling' stamp: 'ErwannNiko 3/30/2011 15:41'!
buildInvalidReadIRNodes
	^ {
		IRInstruction pushLiteral: self.
		IRInstruction send: #invalidRead.
	}! !

!RemovedField methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 3/28/2011 19:54'!
buildInvalidWriteIRNodes
	^ {
		IRInstruction pushLiteral: self.
		IRInstruction send: #invalidWrite.
		IRInstruction popTop.
	}! !

!RemovedField methodsFor: '*SlotExtras-runtime support' stamp: 'ToonVerwaest 3/28/2011 20:39'!
invalidRead
	self error: 'Trying to read from removed field: ', originalSlot name! !

!RemovedField methodsFor: '*SlotExtras-runtime support' stamp: 'ToonVerwaest 3/28/2011 20:56'!
invalidWrite
	self error: 'Trying to write to removed field: ', originalSlot name! !

!RemovedField methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 4/1/2011 18:25'!
rewriteIR: aNode usingModification: aMethodModification
	| addedField  newSlot |
	addedField := aMethodModification
		 addedSlotNamed: originalSlot name ifAbsent: [ ^ nil ].
	newSlot := addedField newSlot.
	aNode nextInstruction delete.
	aNode replaceWith: (IRInstruction pushInstVar: newSlot index ).
	! !

Slot subclass: #ActiveSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!ActiveSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ ``(`,(self compileRead: aClass) value: `,(aNode value)) "! !

!ActiveSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:09'!
initialize: instance
	super write: (ActiveField slot: self self: instance) to: instance! !

!ActiveSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:54'!
inline
	^ true! !

!ActiveSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 13:11'!
write: aValue to: anObject
	(super read: anObject) value: aValue! !

Slot subclass: #CompositeSlot
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!CompositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:06'!
initialize
	super initialize.
	slots := OrderedCollection new.! !

Slot subclass: #DefaultSlot
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!DefaultSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 21:55'!
block: aBlock
	^ self new
		block: aBlock;
		yourself! !

!DefaultSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:56'!
value: anObject
	^ self block: [ anObject ]! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:18'!
= other
	super = other
		ifFalse: [ ^ false ].
	block = other block
		ifFalse: [ ^ false ].
	^ true! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 21:56'!
block
	^ block! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 21:56'!
block: aBlock
	"initializer block"
	block := aBlock! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:16'!
compileInitialize: aClass
	"``( `,(self compileWrite: ``(`,block value) to: aClass)) "! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 12:46'!
initialize: instance
	self write: block value to: instance! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 11:34'!
inline
	^ true! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 12:43'!
storeInitializationOn: aStream
	aStream << self class name << ' block: '.
	block printOn: aStream.! !

!DefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:56'!
value: anObject
	^ self block: [ anObject ]! !

DefaultSlot subclass: #InternalDefaultSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

InternalDefaultSlot subclass: #BitFieldHolderSlot
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 19:01'!
addBit: aSlot
	|bitIndex|
	self isFull
		ifTrue: [ self error: 'BitField is full'].
	
	bitIndex := self nextEmptyBit.
	slots at: bitIndex put: aSlot.
	aSlot bitIndex: bitIndex.
	^ aSlot.
	! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileReadBit: position from: aClass
	"^ ``((`,(self compileRawRead: aClass) bitAt: `,position) == 1)"! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:13'!
compileWrite: aNode bit: position to: aClass
	"^ self compileRawWrite: ``(
			`,(self compileRawRead: aClass)
					bitAt: `,position put: `,(aNode value) asBit)
		to: aClass."! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:51'!
fieldName
	^  'bitField'! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:56'!
initialize
	super initialize.
	self reset.! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:02'!
initialize: instance
	self write: 0 to: instance! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:26'!
isFull
	^ self nextEmptyBit == 0! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:26'!
nextEmptyBit
	^ slots findFirst: [ :val| val == nil].! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:06'!
readBit: position from: anObject
	| integer |
	integer := self internalRead: anObject.
	^ (integer bitAt: position) == 1! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:56'!
reset
	slots := Array new: 30.! !

!BitFieldHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:08'!
write: aBoolean bit: position from: anObject
	| integer |
	integer := self internalRead: anObject.
	integer := integer bitAt: position put: aBoolean asBit.
	self internalWrite: integer to: anObject.
	^ integer.! !

InternalDefaultSlot subclass: #ImmutabilitySwitchSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!ImmutabilitySwitchSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:51'!
fieldName
	^  'immutabilitySwitch'! !

!ImmutabilitySwitchSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:06'!
initialize
	super initialize.
	block := [true].! !

!ImmutabilitySwitchSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:06'!
initialize: instance
	self write: false to: instance! !

!ImmutabilitySwitchSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:06'!
name
	"produce a 'hidden' name which is inaccessible from within normal source code"
	^ (index asString, '_mutable') asSymbol! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:03'!
block: aValue
	self shouldNotImplement.! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:51'!
fieldName
	^ 'internalSlot'! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 16:11'!
finalize: aLayoutBuilder! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:16'!
index: anIndex
	super index: anIndex.
	name := (index asString, self fieldName).! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:04'!
isVisible
	^ false! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:49'!
name
	^ name! !

!InternalDefaultSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:03'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name! !

InternalDefaultSlot subclass: #PropertyHolderSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!PropertyHolderSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 19:12'!
isVisible
	^ false! !

!PropertyHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:51'!
fieldName
	^  'propertyDict'! !

!PropertyHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 12:05'!
initialize
	super initialize.
	block := [Dictionary new].! !

!PropertyHolderSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:54'!
initialize: instance
	self write: (Dictionary new) to: instance! !

Slot subclass: #DependencyInjectionSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

Slot subclass: #EncryptedSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!EncryptedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:43'!
read: anObject
	self shouldBeImplemented! !

!EncryptedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:43'!
write: aValue to: aSlot
	self shouldBeImplemented! !

Slot subclass: #FinalSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!FinalSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 19:09'!
write: aValue on: anObject
	|value|
	value := self read: aValue.
	value ifNil: [ self error: 'can only write once'].
	value := aValue.! !

Slot subclass: #LazySlot
	instanceVariableNames: 'block uninitializedValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:40'!
block
	^ block! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:40'!
block: aBlock
	block := aBlock! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileRead: aClass
	"^ ``( (`,(self compileRawRead: aClass) == `,uninitializedValue)
			ifTrue: [ `,(self compileRawWrite: ``(block value) to: aClass) ]
			ifFalse: [ `,(self compileRawRead: aClass)])"! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:41'!
createValue
	^ block value! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 18:47'!
initialize
	super initialize.
	uninitializedValue := UninitializedField new.! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 18:47'!
initialize: anObject
	self write: uninitializedValue to: anObject.! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:14'!
inline
	^ true! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:26'!
isInitialized: anObject
	^ (self internalRead: anObject) ~= uninitializedValue.! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:47'!
read: anObject
	(self isInitialized: anObject)
		ifFalse: [ self internalWrite: self createValue to: anObject ].
	^ super read: anObject! !

!LazySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/31/2011 13:17'!
storeInitializationOn: aStream
	aStream << self class name << ' block: ' << block asString! !

LazySlot subclass: #SingletonSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!SingletonSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ ``(WriteAccessError signal: 'singleton cannot be changed')"! !

!SingletonSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 18:50'!
initialize: anObject
	"cannot rely on my blocked write:to: method"
	self internalWrite: uninitializedValue to: anObject.! !

!SingletonSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:40'!
write: aValue to: anObject
	self invalidWriteAccess: 'singleton cannot be changed'! !

Slot subclass: #MOPSlot
	instanceVariableNames: 'readBlock writeBlock initializeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:55'!
initialize: anObject
	super write: (initializeBlock value: anObject) to: anObject.! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:12'!
initializeBlock
	^ initializeBlock! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:12'!
initializeBlock: anObject
	initializeBlock := anObject! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:12'!
read: anObject
	^ readBlock value: (super read: anObject)! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:11'!
readBlock
	^ readBlock! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:12'!
readBlock: anObject
	readBlock := anObject! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:14'!
write: aValue to: anObject
	super write: (writeBlock value: aValue value: anObject) to: anObject! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:12'!
writeBlock
	^ writeBlock! !

!MOPSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 22:12'!
writeBlock: anObject
	writeBlock := anObject! !

Slot subclass: #PreconditionSlot
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

PreconditionSlot subclass: #NumberSlot
	instanceVariableNames: 'min max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

NumberSlot subclass: #FloatSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!FloatSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:28'!
numberType
	^ Float! !

NumberSlot subclass: #IntegerSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!IntegerSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/31/2011 14:25'!
numberType
	^ Integer! !

IntegerSlot subclass: #PositiveIntegerSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!PositiveIntegerSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/31/2011 14:59'!
initialize
	min := 0.
	super initialize.! !

!PositiveIntegerSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 19:53'!
min: aNumber
	aNumber < 0
		ifTrue: [ self error: 'Invalid Argument'].
	super min: aNumber.! !

!NumberSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:34'!
max: aMaxNumber
	^ (self new)
		max: aMaxNumber;
		yourself! !

!NumberSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:34'!
min: aMinNumber
	^ (self new)
		min: aMinNumber;
		yourself! !

!NumberSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:33'!
min: aMinNumber max: aMaxNumber
	^ (self new)
		min: aMinNumber;
		max: aMaxNumber;
		yourself! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:20'!
= other
	super = other
		ifFalse: [ ^ false ].
	max = other max
		ifFalse: [ ^ false ].
	min = other min
		ifFalse: [ ^ false ].
	^ true! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 00:44'!
condition: aBlock
	self shouldNotImplement.! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:19'!
conditionBlock
	^ [:value| 
			value ensureNilOrType: self numberType.
			value isNil or: [self inBounds: value]]! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:27'!
inBounds: aNumber
	min ifNotNil: [
		min <= aNumber
			ifFalse: [ ^ false]].
		
	max ifNotNil: [
		aNumber <= max
			ifFalse: [ ^ false]].
		
	^ true.! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:23'!
initialize
	super initialize.
	condition := self conditionBlock.! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:32'!
max
	^ max! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:48'!
max: aNumber
	max := aNumber! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:32'!
min
	^ min! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:48'!
min: aNumber
	min := aNumber! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:34'!
min: aMinNumber max: aMaxNumber
	self min: aMinNumber.
	self max: aMaxNumber.! !

!NumberSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:28'!
numberType
	^ Number! !

!PreconditionSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:19'!
= other
	super = other
		ifFalse: [ ^ false ].
	condition = other condition
		ifFalse: [ ^ false ].
	^ true! !

!PreconditionSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 00:35'!
condition
	^ condition! !

!PreconditionSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:47'!
condition: aBlock
	condition := aBlock! !

!PreconditionSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:47'!
preconditionFailedOn: aValue
	(SlotConditionFailed argument: aValue slot: self) 
				signal: 'Precondition ', condition asString, ' failed'! !

!PreconditionSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:30'!
storeInitializationOn: aStream
	aStream << self class name << ' condition: ' << condition asString! !

!PreconditionSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:18'!
write: aValue to: anObject
	(condition value: aValue)
		ifFalse: [ self preconditionFailedOn: aValue].
	super write: aValue to: anObject.! !

Slot subclass: #ReadOnlySlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!ReadOnlySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:39'!
write: aValue to: anObject
	self invalidWriteAccess: name, ' is read-only'.! !

Slot subclass: #RemoteSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!Slot methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidReadAccess
	ReadAccessError signal! !

!Slot methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidReadAccess: aMessage
	ReadAccessError signal: aMessage! !

!Slot methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidWriteAccess
	WriteAccessError signal! !

!Slot methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidWriteAccess: aMessage
	WriteAccessError signal: aMessage! !

Slot subclass: #TypedSlot
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

TypedSlot subclass: #OppositeSlot
	instanceVariableNames: 'opposite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

OppositeSlot subclass: #ManySlot
	instanceVariableNames: 'oppositeHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:54'!
add: aValue to: anObject
	(self read: anObject) addSilently: aValue.! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:18'!
compileAdd: aValueNode to: anObjectNode
	"cannot use direct instance variable access of anObjectNode. This is an external access to anObjectNode"
	"^ ``(`,anObjectNode ifNotNil: [ 
			(`,anObjectNode instVarAt: `,index) addSilently: `,aValueNode ])."! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:16'!
compileInitialize: aClass
	"``( `,(self compileWrite: 
			``(HotSet new
					oppositeSlot: `,opposite;
					myself: self;
					type: `,(self oppositeHost);
					yourself) 
			to: aClass)) 
				"
	! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:18'!
compileRemove: aValueNode from: anObjectNode
	"cannot use direct instance variable access of anObjectNode. This is an external access to anObjectNode"
	"^ ``((`,anObjectNode instVarAt: `,index) removeSilently: `,aValueNode)"! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ ``([ |hotSet| 
			hotSet := `,(self compileRead: aClass). 
			hotSet removeAll.
		
			`,(aNode value) ensureType: Collection.
			hotSet addAll: `,(aNode value)] value)"! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:41'!
initialize
	super initialize.
	type := HotSet! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:41'!
initialize: anObject
	|set|
	set := HotSet new
		oppositeSlot: opposite;
		myself: anObject;
		type: self oppositeHost.
	super internalWrite: set to: anObject.
	! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:40'!
oppositeHost
	^ oppositeHost! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 14:20'!
oppositeHost: aClass
	oppositeHost := aClass! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:54'!
remove: aValue from: anObject
	(self read: anObject) removeSilently: aValue.! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:46'!
type: aClass
	self oppositeHost: aClass.! !

!ManySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:56'!
write: aValueCollection to: anObject
	|hotSet|
	hotSet := self read: anObject.
	hotSet removeAll.
	
	aValueCollection ensureType: Collection.
	hotSet addAll: aValueCollection.! !

OppositeSlot subclass: #OneSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:54'!
add: aValue to: anObject
	super write: aValue to: anObject.! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:18'!
compileAdd: aValueNode to: anObjectNode
	"cannot use direct instance variable access of anObjectNode. This is an external access to anObjectNode"
	
	"^ ``( `,anObjectNode ifNotNil: [ `,anObjectNode instVarAt: `,index put: `,aValueNode ] )"! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:18'!
compileRemove: aValueNode from: anObjectNode
	"cannot use direct instance variable access of anObjectNode. This is an external access to anObjectNode"
	"^ ``(`,anObjectNode instVarAt: `,index put: nil)"
	! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ ``([ `,(super compileRead: aClass)
				ifNotNilDo: [ :oldValue|
					`,(opposite compileRemove: ``(self) from: ``(oldValue))].
			`,(super compileWrite: aNode value to: aClass).
			`,(opposite compileAdd: ``(self) to: aNode value) ] value)."! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/7/2011 14:21'!
oppositeHost
	^ type! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/7/2011 14:21'!
oppositeHost: aClass
	type := aClass.! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:19'!
remove: aValue from: anObject
	super write: nil to: anObject.
	! !

!OneSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 13:20'!
write: aValue to: anObject

	(self internalRead: anObject)
		ifNotNilDo: [ :oldValue|
			opposite remove: anObject from: oldValue].
		
	super write: aValue to: anObject.
	
	self flag: 'Allow settings for nil'.
	aValue ifNotNil: [opposite add: anObject to: aValue].! !

!OppositeSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 13:57'!
new
	self == OppositeSlot
		ifTrue: [ self shouldNotImplement ].
	^ super new! !

!OppositeSlot class methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 15:50'!
opposite: aSymbol
	^ self new
		opposite: aSymbol;
		yourself! !

!OppositeSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 13:20'!
opposite: aSymbol class: aClass
	^ self new
		opposite: aSymbol class: aClass;
		yourself! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:36'!
= other
	super = other
		ifFalse: [ ^ false ].
	
	"to avoid simple loops"
	self == other
		ifTrue: [ ^ true].
		
	"to avoid simple loops"
	self == other opposite
		ifTrue: [ ^ false].
		
	"to avoid simple loops"
	opposite == other opposite
		ifFalse: [ ^ true ].
		
	opposite = other opposite
		ifFalse: [ ^ false ].
		
	^ true.! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:13'!
doBla
	self instVarNamed: #opposite put: self! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/7/2011 14:31'!
finalize: aLayoutBuilder
	(opposite isKindOf: Slot)
		ifTrue: [ ^ self ].
	
	self oppositeHost isSymbol
		ifTrue: [ self oppositeHost: (Smalltalk at: self oppositeHost)].
	
	self oppositeHost isNil "opposite is with the same layout"
		ifTrue: [ 
			self halt.
			self oppositeHost: aLayoutBuilder host.
			 ^ self instVarNamed: #opposite put:
				(opposite == name
					ifTrue: [ self ]
					ifFalse: [ (aLayoutBuilder host layout atName: name)])].
	
	opposite isSymbol 
		ifFalse: [ ^ self ].
		
	"cannot use the slot directly due to assumption that the opposite is a slot and not a symbol"
	self instVarNamed: #opposite 
			put: (self oppositeHost layout atName: opposite 
				ifAbsent: [ opposite ]).
	
	opposite isSymbol 
		ifFalse: [ 
			opposite ensureType: OppositeSlot.
			opposite opposite: self ].! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:50'!
inline
	^ true! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 17:47'!
opposite
	^ opposite! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:08'!
opposite: aSlotOrSymbol

	"cannot use the slot directly due to assumption that the opposite is a slot and not a symbol"
	(aSlotOrSymbol isSymbol or: [ opposite isSymbol])
		ifFalse: [ opposite := aSlotOrSymbol ]
		ifTrue: [ self instVarNamed: #opposite put: aSlotOrSymbol]! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 13:20'!
opposite: aSymbol class: aClass
	self opposite: aSymbol.
	self oppositeHost: aClass.! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 13:56'!
oppositeHost
	self subclassResponsibility! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 13:56'!
oppositeHost: aClass
	self subclassResponsibility! !

!OppositeSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:17'!
storeInitializationOn: aStream

	aStream << self class name; 
		<< ' opposite: '.
	
	(opposite isKindOf: Slot)
		ifTrue: [ aStream store: opposite name]
		ifFalse: [ aStream store: opposite].
	
	self oppositeHost 
		ifNil: [ ^ self].
	
	aStream << ' class: '.
	self oppositeHost = self
		ifTrue: [ 
			(InvalidArgument value: self) signal: 'cannot be my own opposite'.
			aStream << 'self'].
		
	aStream store: (self oppositeHost isBehavior 
							ifTrue:[ self oppositeHost name] 
							ifFalse: [ self oppositeHost ])! !

!TypedSlot class methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 12:54'!
type: aClass
	^ self new
		type: aClass;
		yourself! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:20'!
= other
	super = other
		ifFalse: [ ^ false ].
	type = other type
		ifFalse: [ ^ false ].
		
	^ true.! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:59'!
compileStaticallyWrite: aNode to: aClass
	aNode value value ensureNilOrType: type.
	^ self compileRawWrite: aNode value to: aClass.! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileWrite: aNode to: aClass
	"aNode value isLiteral
		ifTrue: [ ^ self compileStaticallyWrite: aNode to: aClass].
	^ ``([ `,(aNode value) ensureNilOrType: `,type.
			`,(super compileWrite: aNode to: aClass)] value)."! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:41'!
inline
	^ self class == TypedSlot! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:43'!
storeInitializationOn: aStream
	aStream << self class name << ' type: ' << type name! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 01:43'!
type

	^ type! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:58'!
type: aClass
	type := aClass! !

!TypedSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:55'!
write: aValue to: anObject
	aValue ensureNilOrType: type.
	super write: aValue to: anObject.! !

Slot subclass: #VirtualSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

VirtualSlot subclass: #AliasSlot
	instanceVariableNames: 'alias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:21'!
= other
	super = other
		ifFalse: [ ^ false ].
	alias = other alias
		ifFalse: [ ^ false ].
		
	^ true.! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:37'!
alias
	^ alias! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 00:41'!
alias: aSlot
	alias == self 
		ifTrue: [ InvalidArgument argument: aSlot; signal: 'Cannot use myself as an alias'].
	alias := aSlot! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileRead: aClass
	"redirect compilation to alias slot"
	"^ ``( `,(alias compileRead: aClass))"! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"redirect compilation to alias slot"
	"^ ``( `,(alias compileWrite: aNode to: aClass))"! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:03'!
finalize: aLayoutBuilder
	alias := aLayoutBuilder resolveSlot: alias! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:50'!
inline
	^ true! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:36'!
read: anObject
	^ alias read: anObject.! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 18:05'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name; 
		nextPutAll: ' alias: '.
	aStream store: alias name! !

!AliasSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:36'!
write: aValue to: anObject
	alias write: aValue to: anObject.! !

VirtualSlot subclass: #BitSlot
	instanceVariableNames: 'bitIndex bitHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:22'!
= other
	super = other
		ifFalse: [ ^ false ].
		
	bitIndex = other bitIndex
		ifFalse: [ ^ false ].
		
	bitHolder = other bitHolder
		ifFalse: [ ^ false ].
		
	^ true.! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:41'!
bitHolder
	^ bitHolder! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:41'!
bitHolder: aSlot
	bitHolder := aSlot! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/31/2011 14:57'!
bitIndex
	^ bitIndex! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/31/2011 14:57'!
bitIndex: anObject

	bitIndex := anObject! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:11'!
compileRead: aClass
	^ bitHolder compileReadBit: bitIndex from: aClass! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ self bitHolder compileWrite: aNode bit: bitIndex to: aClass"! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:41'!
inline
	^ true! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 16:57'!
parentScopeFor: aScope
	|newScope|
	aScope withParentScopesDo: [ :scope|
		((scope isKindOf: BitFieldScope) and: [ scope isFull not])
			ifTrue: [
				bitHolder := scope bitField.
				bitHolder addBit: self.
				^ aScope]].
		
	newScope := BitFieldScope withParent: aScope.
	bitHolder := newScope bitField.
	bitHolder addBit: self.
	^ newScope! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:53'!
read: anObject
	^ bitHolder readBit: bitIndex from: anObject! !

!BitSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 16:53'!
write: aValue to: anObject
	^ bitHolder write: aValue bit: bitIndex from: anObject! !

VirtualSlot subclass: #ClassSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

VirtualSlot subclass: #PropertySlot
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!PropertySlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 21:41'!
dict: aSlot
	^ self new
		dict: aSlot;
		yourself! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:22'!
= other
	super = other
		ifFalse: [ ^ false ].
		
	dict = other dict
		ifFalse: [ ^ false ].
		
	^ true.! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileRead: aClass
	"^ ``(`,(dict compileRead: aClass) at: `,name ifAbsent: nil)"! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ ``( `,(dict compileRead: aClass) at: `,name put: `,(aNode value))"! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 21:41'!
dict
	^ dict! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 21:41'!
dict: aSlot
	dict := aSlot! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:25'!
inline
	^ true! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 16:51'!
parentScopeFor: aScope
	aScope withParentScopesDo: [ :scope|
		(scope isKindOf: PropertyScope)
			ifTrue: [
				dict := scope.
				^ aScope]].
		
	dict := PropertyScope withParent: aScope.
	^ dict! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 17:00'!
read: anObject
	^ (dict read: anObject) at: name ifAbsent: [ nil].! !

!PropertySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/5/2011 22:17'!
write: aValue to: anObject
	^ (dict read: anObject) at: name put: aValue.! !

VirtualSlot subclass: #RGBSlot
	instanceVariableNames: 'red green blue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!RGBSlot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/7/2011 15:00'!
red: r green: g blue: b
	^ self new
		red: r;
		green: g;
		blue: b;
		yourself! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:22'!
= other
	super = other
		ifFalse: [ ^ false ].
		
	red = other red
		ifFalse: [ ^ false ].
		
	green = other green
		ifFalse: [ ^ false ].
		
	blue = other blue
		ifFalse: [ ^ false ].
		
	^ true.! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:23'!
blue
	^ blue! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:23'!
blue: anObject
	blue := anObject! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileRead: aClass
	"^ ``( ((`,(red compileRead: aClass) bitAnd: 16rFF)<< 16) 
			+ ((`,(green compileRead: aClass) bitAnd: 16rFF) << 8)
			+ (`,(blue compileRead: aClass) bitAnd: 16rFF))."! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"redirect compilation to alias slot"
	"^ ``( [`,(red   compileWrite: ``((`,(aNode value) bitAnd: 16rFF0000) >> 16) to: aClass).
			`,(green compileWrite: ``((`,(aNode value) bitAnd: 16r00FF00) >>  8) to: aClass).
			`,(blue  compileWrite: ``( `,(aNode value) bitAnd: 16r0000FF)        to: aClass).
			`,(aNode value)] value)."! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/7/2011 12:09'!
finalize: aLayoutBuilder
	red := aLayoutBuilder resolveSlot: red.
	green := aLayoutBuilder resolveSlot: green.
	blue := aLayoutBuilder resolveSlot: blue.! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:23'!
green
	^ green! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:23'!
green: anObject
	green := anObject! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:50'!
inline
	^ true! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 12:44'!
read: anObject

	^ (((red read: anObject) bitAnd: 16rFF)<< 16) 
			+ (((green read: anObject) bitAnd: 16rFF) << 8)
			+ ((blue read: anObject) bitAnd: 16rFF).! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:23'!
red
	^ red! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 17:23'!
red: anObject
	red := anObject! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/7/2011 15:00'!
red: r green: g blue: b
	self red: r.
		self green: g.
		self blue: b.! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/7/2011 15:01'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name; 
		nextPutAll: ' red: ';  store: red name;
		nextPutAll: ' green: ';  store: green name;
		nextPutAll: ' blue: ';  store: blue name.! !

!RGBSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 12:45'!
write: aValue to: anObject
	red write: ((aValue bitAnd: 16rFF0000) >> 16)   to: anObject.
	green write: ((aValue bitAnd: 16r00FF00) >>  8) to: anObject.
	blue write:  (aValue bitAnd: 16r0000FF)         to: anObject.! !

VirtualSlot subclass: #SelfSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!SelfSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 12:11'!
initialize
	super initialize.
	name := #self.! !

!SelfSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 12:12'!
name: aSymbol
	aSymbol = #self
		ifFalse: [ self error: 'Invalid name'].! !

!SelfSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 12:10'!
read: anObject
	^ anObject! !

!SelfSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 12:11'!
write: aValue to: anObject
	^ self invalidWriteAccess: 'cannot change self'! !

!VirtualSlot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/14/2011 19:43'!
inline
	^ true! !

!VirtualSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:38'!
needsField
	^ false! !

!VirtualSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:34'!
read: anObject
	self subclassResponsibility! !

!VirtualSlot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 14:32'!
size
	^ 0! !

!VirtualSlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/4/2011 14:34'!
write: aValue to: anObject
	self subclassResponsibility! !

Slot subclass: #WriteOnlySlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!WriteOnlySlot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:39'!
read: anObject
	self invalidReadAccess: name, ' is write-only'.! !

!ModifiedField methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 3/28/2011 17:53'!
applyToIR: aFieldAccess
	aFieldAccess number: self newFieldIndex! !

!IRInstruction methodsFor: '*SlotExtras' stamp: 'ErwannNiko 3/30/2011 15:57'!
nextInstruction
	^ sequence after: self! !

LayoutClassScope variableSubclass: #LayoutTraitScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Layout'!

!ShiftedField methodsFor: '*SlotExtras-recompiling' stamp: 'ToonVerwaest 3/28/2011 20:27'!
applyToIR: aFieldAccess
	aFieldAccess number: aFieldAccess number + shift! !

Trait subclass: #StatefulTrait
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Traits'!

!StatefulTrait class methodsFor: 'instance creation' stamp: 'ToonVerwaest 4/2/2011 14:35'!
named: aName layout: layoutClass slots: slotArray uses: aTraitComposition category: aCategory
	| result |
	result := super named: aName uses: aTraitComposition category: aCategory.
	result layout: (layoutClass new
						slotScope: (LayoutEmptyScope instance
										extend: slotArray
										as: LayoutTraitScope)).
	^ result! !

!StatefulTrait methodsFor: 'instance variables' stamp: 'ToonVerwaest 3/31/2011 22:42'!
allInstVarNames
	^ layout instanceVariables! !

!StatefulTrait methodsFor: 'layout' stamp: 'ToonVerwaest 4/2/2011 17:18'!
composeWithLayout: classLayout
	^ classLayout forkLayout: layout! !

!StatefulTrait methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 21:01'!
copyTraitExpression
	| result |
	result := self shallowCopy.
	result layout: layout copy.
	result layout host: result.
	^ result! !

!StatefulTrait methodsFor: 'filein/out' stamp: 'ToonVerwaest 3/31/2011 21:54'!
definition
	"Answer a String that defines the receiver"

	^String streamContents: [:stream |
		stream << self class name.
		stream << ' named: ';
				store: self name.
		stream lf; tab; << 'layout: '.
		stream << layout class name.
		stream lf; tab; << 'slots: '.
		layout printSlotDefinitionOn: stream.
		stream lf; tab; << 'uses: ';
				<< self traitCompositionString.
		stream lf; tab; << 'category: ';
				store: self category].! !

!StatefulTrait methodsFor: 'instance variables' stamp: 'ToonVerwaest 3/31/2011 22:42'!
instVarNames
	" At the moment we don't support extending traits. "
	^ layout instanceVariables! !

!StatefulTrait methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 18:53'!
layout
	^ layout! !

!StatefulTrait methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 21:50'!
layout: aLayout
	layout := aLayout.
	layout host: self! !

!StatefulTrait methodsFor: 'compiling' stamp: 'ToonVerwaest 4/2/2011 19:09'!
variablesAndOffsetsDo: aBinaryBlock
	"This is part of the interface between the compiler and a class's instance or field names.
	 The class should enumerate aBinaryBlock with the instance variable name strings and
	 their integer offsets.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	"(superInstSize := superclass notNil ifTrue: [superclass instSize] ifFalse: [0]) > 0 
		ifTrue: [superclass instVarNamesAndOffsetsDo: aBinaryBlock]."
	layout allVisibleSlots do: [ :slot |
		aBinaryBlock value: slot name value: slot index ]! !

IdentitySet subclass: #HotSet
	instanceVariableNames: 'oppositeSlot type myself'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!HotSet methodsFor: 'adding' stamp: 'CamilloBruni 3/10/2011 17:36'!
add: newObject
	newObject ensureType: type.
	super add: newObject.
	oppositeSlot add: myself to: newObject.! !

!HotSet methodsFor: 'adding' stamp: 'CamilloBruni 3/10/2011 14:49'!
addSilently: newObject
	^ super add: newObject.! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 14:43'!
myself
	^ myself! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 14:44'!
myself: anObject
	myself := anObject.! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/4/2011 14:58'!
oppositeSlot
	^ oppositeSlot! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/4/2011 14:58'!
oppositeSlot: aSlot
	oppositeSlot := aSlot.! !

!HotSet methodsFor: 'removing' stamp: 'CamilloBruni 3/10/2011 14:43'!
remove: oldObject ifAbsent: aBlock
	| anObject |
	anObject := super remove: oldObject 
			ifAbsent: [ ^ aBlock value].
	oppositeSlot remove: myself from: oldObject.
	^ anObject.! !

!HotSet methodsFor: 'removing' stamp: 'CamilloBruni 3/10/2011 14:51'!
removeAll
	self do: [ :each|	
		oppositeSlot remove: myself from: each].
	^ super removeAll.! !

!HotSet methodsFor: 'removing' stamp: 'CamilloBruni 3/24/2011 14:49'!
removeSilently: oldObject
	"don't trigger updates"
	^  super remove: oldObject ! !

!HotSet methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 16:49'!
type: aType
	type := aType! !

TestCase subclass: #SlotLayoutBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-LayoutBuilder'!

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:39'!
builderClass
	^ SlotLayoutBuilder! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:06'!
testBasicByteLayout
	self should: [
			self builderClass makeByte: [ :builder|
				builder scope: Object layout slotScope.
				builder slot: (#a => Slot).
			]]
		raise: Error.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:08'!
testBasicLayoutProperty
	| layout |
	self fail.
	layout := self builderClass makeVariable: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => Slot property).
		builder slot: (#b => Slot).
	].! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:03'!
testBasicObjectLayout
	| layout slots|
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].

	slots := layout allSlots.
	
	self assert:(layout isKindOf: PointerLayout).
	
	self assert: slots size = 2.
	self assert: layout fieldSize = 2.
	
	self assert: (slots at: 1) name = #a.
	self assert: (slots at: 2) name = #b.
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:03'!
testBasicVariableLayout
	| layout slots|
	layout := self builderClass makeVariable: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => Slot).
		builder slot: (#b => Slot).
	].

	slots := layout allSlots.
	self assert:(layout isKindOf: VariableLayout).
	
	self assert: slots size = 2.
	self assert: layout fieldSize = 2.
	
	self assert: (slots at: 1) name = #a.
	self assert: (slots at: 2) name = #b.
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:00'!
testBasicWordLayout
	self should: [
			self builderClass makeWord: [ :builder|
				builder slot: (#a => Slot).
			]]
		raise: Error.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 17:04'!
testBitAndPropertySlots
	| layout slots |
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => BitSlot).
		builder slot: (#b => PropertySlot).
	].
	
	slots := layout allSlots.
	
	self assert: slots size = 4.
	self assert: layout fieldSize = 2.

	self assert: ((slots at: 1) isKindOf: BitFieldHolderSlot).
	self assert: ((slots at: 2) isKindOf: PropertyHolderSlot).
	self assert: ((slots at: 3) isKindOf: BitSlot).
	self assert: ((slots at: 4) isKindOf: PropertySlot).
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.
	self assert: (slots at: 3) index = 2.
	self assert: (slots at: 4) index = 3.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 14:07'!
testBitSlots
	| layout slots |
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#a => BitSlot).
		builder slot: (#b => BitSlot).
	].

	slots := layout allSlots.
	
	self assert: layout fieldSize = 1.
	self assert: slots size = 3.
	

	self assert: ((slots at: 1) isKindOf: BitFieldHolderSlot).
	self assert: ((slots at: 2) isKindOf: BitSlot).
	self assert: ((slots at: 3) isKindOf: BitSlot).
	
	self assert: (slots at: 1) index = 1.
	self assert: (slots at: 2) index = 2.
	self assert: (slots at: 3) index = 2.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 14:31'!
testBitSlotsOverflow
	| layout slots bitFieldHolder|
	layout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		1 to: 40 do: [:index| 
			builder slot: (('bit_',index asString) asSymbol => BitSlot)]
	].
	
	slots := layout allSlots.
	
	self assert: slots size = (40 + 2).
	self assert: layout fieldSize = 2.
	
	bitFieldHolder := slots at: 1.
	self assert: (bitFieldHolder isKindOf: BitFieldHolderSlot).
	self assert: bitFieldHolder index = 1.
	self assert: bitFieldHolder isFull.

	bitFieldHolder := slots at: 2.
	self assert: (bitFieldHolder isKindOf: BitFieldHolderSlot).
	self assert: bitFieldHolder index = 2.
	self deny: bitFieldHolder isFull.
	
	3 to: 32 do: [:index| |slot|
		slot := slots at: index.
		self assert: (slot isKindOf: BitSlot).
		self assert: slot index = 2 ].
	
	33 to: 42 do: [:index| |slot|
		slot := slots at: index.
		self assert: (slot isKindOf: BitSlot).
		self assert: slot index = 3 ].! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:43'!
testDuplicateSlot
	
	self should: [
		 self builderClass make: [ :builder|
				builder scope: Object layout slotScope.
				builder slot: #AAA.
				builder slot: #AAA.
			]]
		raise: SlotDuplicationConflict.! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:38'!
testParentDuplicateSlots
	| parentLayout |
	
	parentLayout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: (#b => Slot).
	].

	self should: [self builderClass make: [ :builder|
			builder scope: parentLayout slotScope.
			builder slot: (#b => Slot).
		]]
		raise: SlotDuplicationConflict.
		! !

!SlotLayoutBuilderTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/6/2011 16:55'!
testParentPropertySlots
	| layout parentLayout slots |
	parentLayout := self builderClass make: [ :builder|
		builder scope: Object layout slotScope.
		builder slot: #a1.
		builder slot: (#b => PropertySlot).
		builder slot: #a2.
	].

	layout := self builderClass make: [ :builder|
		builder scope: parentLayout slotScope.
		builder slot: (#c => PropertySlot).
	].

	slots := layout allSlots.
	
	self assert: layout fieldSize = 3.
	self assert: slots size = 5.
	
	self assert: ((slots at: 1) isKindOf: PropertyHolderSlot).
	self assert: ((slots at: 2) isKindOf: Slot).
	self assert: ((slots at: 3) isKindOf: PropertySlot).
	self assert: ((slots at: 4) isKindOf: Slot).
	self assert: ((slots at: 5) isKindOf: PropertySlot).! !

TestCase subclass: #SlotTest
	instanceVariableNames: 'slotObject layout slotObjectClass slot slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

SlotTest subclass: #ActiveSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/7/2011 12:10'!
slot
	^ layout resolveSlot: #active! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 21:57'!
slotClass
	^ ActiveSlot! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 21:58'!
slotTestObjectClass
	^ ActiveSlotTestObject! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:16'!
testUpdate
	| field |
	slotObject active for: self notify: [ :value| field := value].
	
	self assert: field = nil.
	slotObject active: 2.
	self assert: field = 2.
	
	slotObject active value: 3.
	self assert: field = 3.
	self assert: slotObject active value = 3.! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:42'!
testUpdateMethod
	slotObject active for: slotObject notify: (slotObject class lookupSelector: #field3:).
	
	self assert: slotObject field3 = nil.
	slotObject active: 2.
	self assert: slotObject field3 = 2.
	
	slotObject active value: 3.
	self assert: slotObject field3 = 3.
	self assert: slotObject active value = 3.! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:34'!
testUpdateMethodName
	slotObject active for: slotObject notify: #field3:.
	
	self assert: slotObject field3 = nil.
	slotObject active: 2.
	self assert: slotObject field3 = 2.
	
	slotObject active value: 3.
	self assert: slotObject field3 = 3.
	self assert: slotObject active value = 3.! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:19'!
testUpdateSlot
	slotObject active for: slotObject notify: self slot3.
	
	self assert: slotObject field3 = nil.
	slotObject active: 2.
	self assert: slotObject field3 = 2.
	
	slotObject active value: 3.
	self assert: slotObject field3 = 3.
	self assert: slotObject active value = 3.! !

!ActiveSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:19'!
testUpdateSlotName
	slotObject active for: slotObject notify: #field3.
	
	self assert: slotObject field3 = nil.
	slotObject active: 2.
	self assert: slotObject field3 = 2.
	
	slotObject active value: 3.
	self assert: slotObject field3 = 3.
	self assert: slotObject active value = 3.! !

SlotTest subclass: #LazySlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!LazySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:21'!
slotClass
	^ LazySlot! !

!LazySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:49'!
slotTestObjectClass
	^ LazySlotTestObject! !

!LazySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:34'!
testInitialize
	self slot block: [ 1111 ].

	self assert: (self slot read: slotObject) == 1111.
		
	self slot block: [ 2222 ].
	self assert: (self slot read: slotObject) == 1111.
	self slot write: 3333 to: slotObject.
	self assert: (self slot read: slotObject) == 3333.	! !

!LazySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:32'!
testInitialized
	|instance|
	instance :=  (self slotTestObjectClass new).
	
	self deny: (slot isInitialized: slotObject).
	self slot write: instance to: slotObject.	
	self assert: (slot isInitialized: slotObject).! !

!LazySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:03'!
testWriteTo
	|instance|
	instance :=  (self slotTestObjectClass new).
	
	self deny: (slot isInitialized: slotObject).
	self slot write: instance to: slotObject.
	self assert: slotObject field = instance.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

LazySlotTest subclass: #SingletonSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!SingletonSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:36'!
slotClass
	^ SingletonSlot! !

!SingletonSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:49'!
slotTestObjectClass
	^ SingletonSlotTestObject! !

!SingletonSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:24'!
testInitialize
	self assert: (self slot read: slotObject) class == Object.! !

!SingletonSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:42'!
testInitialized
	|instance|
	instance :=  (self slotTestObjectClass new).
	
	self deny: (slot isInitialized: slotObject).
	self slot read: slotObject.
	self assert: (slot isInitialized: slotObject).! !

!SingletonSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:06'!
testRead
	|singleton|
	singleton := slotObject field.
	self assert: (self slot read: slotObject) == singleton.
	self assert: slotObject field == singleton.! !

!SingletonSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:20'!
testWriteTo
	self should: [self slot write: 1 to: slotObject] raise: WriteAccessError.! !

SlotTest subclass: #PreconditionSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

PreconditionSlotTest subclass: #NumberSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

NumberSlotTest subclass: #FloatSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!FloatSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 16:52'!
slotClass
	^ FloatSlot! !

!FloatSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:44'!
slotTestObjectClass
	^ FloatSlotTestObject! !

!FloatSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:02'!
testRead
	slotObject field: 2.0.
	self assert: slotObject field = 2.0.
	self assert: (self slot read: slotObject) = 2.0.! !

!FloatSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:04'!
testWriteTo
	self assert: slotObject field = nil.
	self slot write: 2.0 to: slotObject.
	self assert: slotObject field = 2.0.
	
	self slot write: -2.5 to: slotObject.
	self assert: slotObject field = -2.5.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

!FloatSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:17'!
testWriteToFail
	super testWriteToFail.
	self should: [self slot write: -2 to: slotObject] raise: InvalidType.
	self should: [self slot write: 2 to: slotObject] raise: InvalidType.
	self should: [self slot write: 2/3 to: slotObject] raise: InvalidType.! !

NumberSlotTest subclass: #IntegerSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!IntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:48'!
slotClass
	^ IntegerSlot! !

!IntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:45'!
slotTestObjectClass
	^ IntegerSlotTestObject! !

!IntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:03'!
testWriteTo
	self assert: slotObject field = nil.
	self slot write: 2 to: slotObject.
	self assert: slotObject field = 2.
	
	self slot write: -2 to: slotObject.
	self assert: slotObject field = -2.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

!IntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:17'!
testWriteToFail
	super testWriteToFail.
	self should: [self slot write: 2.5 to: slotObject] raise: InvalidType.
	self should: [self slot write: -1.4 to: slotObject] raise: InvalidType.
	self should: [self slot write: 2/3 to: slotObject] raise: InvalidType.
	self should: [self slot write: Number to: slotObject] raise: InvalidType.! !

IntegerSlotTest subclass: #PositiveIntegerSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!PositiveIntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 16:52'!
slotClass
	^ PositiveIntegerSlot! !

!PositiveIntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:46'!
slotTestObjectClass
	^ PositiveIntegerSlotTestObject! !

!PositiveIntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:04'!
testWriteTo
	self assert: slotObject field = nil.
	self slot write: 2 to: slotObject.
	self assert: slotObject field = 2.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

!PositiveIntegerSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:15'!
testWriteToFail
	super testWriteToFail.
	self should: [self slot write: -2 to: slotObject] raise: SlotConditionFailed.! !

!NumberSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 16:51'!
slotClass
	^ NumberSlot! !

!NumberSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:44'!
slotTestObjectClass
	^ NumberSlotTestObject! !

!NumberSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:04'!
testWriteTo
	self assert: slotObject field = nil.
	self slot write: 2 to: slotObject.
	self assert: slotObject field = 2.
	
	self slot write: -2.5 to: slotObject.
	self assert: slotObject field = -2.5.
	
	self slot write: (5/2) to: slotObject.
	self assert: slotObject field = (5/2).
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

!NumberSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:15'!
testWriteToFail
	self should: [self slot write: Number to: slotObject] raise: InvalidType.
	self should: [self slot write: slotObject to: slotObject] raise: InvalidType.! !

!PreconditionSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 16:51'!
slotClass
	^ PreconditionSlot! !

!PreconditionSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:45'!
slotTestObjectClass
	^ PreconditionSlotTestObject! !

!PreconditionSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:31'!
testWriteTo
	self assert: slotObject field = nil.
	self slot write: 2 to: slotObject.
	self assert: slotObject field = 2.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

!PreconditionSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:31'!
testWriteToFail
	self should: [self slot write: 1 to: slotObject] raise: SlotConditionFailed.
	self should: [self slot write: 3 to: slotObject] raise: SlotConditionFailed.
	self should: [self slot write: slotObject to: slotObject] raise: SlotConditionFailed.! !

!SlotTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:05'!
shouldInheritSelectors
	^ true! !

!SlotTest methodsFor: 'converting' stamp: 'CamilloBruni 4/4/2011 15:40'!
assertSlotAt: index named: name
	self assert: (slots at: index) name = name.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/20/2011 15:56'!
newTestObjectInstance
	^ self slotTestObjectClass new.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 4/4/2011 15:36'!
prepareTestObjectClass
	slotObjectClass initialize.
	! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 4/4/2011 17:28'!
setUp
	slotObjectClass := self slotTestObjectClass.
	self prepareTestObjectClass.
	slotObject := self newTestObjectInstance.
	layout := slotObjectClass layout.
	slots := layout allSlots.
	slot := slots at: 4.! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:47'!
slot
	^ slots at: 4! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 17:42'!
slot1
	^  slots at: 1! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 17:42'!
slot2
	^  slots at: 2! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 17:42'!
slot3
	^  slots at: 3! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 15:44'!
slotClass
	^ Slot! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 15:51'!
slotTestObjectClass
	^ SlotTestObject! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 15:38'!
testIndex
	self assert: self slot index = 4.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 16:21'!
testLayout
	self assertSlotAt: 1 named: #field1.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 16:02'!
testRead
	slotObject field: 2.
	self assert: slotObject field = 2.
	self assert: (self slot read: slotObject) = 2.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 15:39'!
testSize
	self assert: self slot size = 1.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 4/4/2011 15:56'!
testWriteTo
	|instance|
	instance :=  (self slotTestObjectClass new).
	
	self assert: slotObject field = nil.
	self slot write: instance to: slotObject.
	self assert: slotObject field = instance.
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

SlotTest subclass: #TypedSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

TypedSlotTest subclass: #ManySlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!ManySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:45'!
slotClass
	^ ManySlot! !

!ManySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:29'!
slotTestObjectClass
	^ ManySlotTestObject! !

!ManySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:40'!
testInvalidTypeForManySlot
	self deny: slotObject many isNil.
	self should: [slot write: 1 to: slotObject] raise: InvalidType.! !

!ManySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:32'!
testLayout
	self assertSlotAt: 4 named: #many.! !

!ManySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:41'!
testRead
	|instance|
	instance := OneSlotTestObject new.
	
	slotObject field: {instance}.
	
	self assert: ((self slot read: slotObject) includes: instance).! !

!ManySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:36'!
testWriteTo
	|instance|
	instance :=  OneSlotTestObject new.
	
	self assert: (slotObject field isKindOf: HotSet).
	self should: [self slot write: instance to: slotObject ] raise: InvalidType.
	self slot write: {instance} to: slotObject.
	self assert: slotObject field size = 1.
	self assert: (slotObject field includes: instance).
	
	self should: [ self slot write: nil to: slotObject ] raise: InvalidType.
	self assert: (slotObject field isKindOf: HotSet).! !

TypedSlotTest subclass: #OneSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!OneSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:45'!
slotClass
	^ OneSlot! !

!OneSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:29'!
slotTestObjectClass
	^ OneSlotTestObject! !

!OneSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:40'!
testInvalidTypeForOneSlot
	self assert: slotObject one isNil.
	self should: [slot write: 1 to: slotObject] raise: InvalidType.! !

!OneSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:32'!
testLayout
	self assertSlotAt: 4 named: #one.! !

!OneSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:38'!
testRead
	|instance|
	instance := ManySlotTestObject new.
	
	self assert: slotObject field = nil.
	slotObject field: instance.
	
	self assert: (self slot read: slotObject) == instance.! !

!OneSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 17:37'!
testWriteTo
	|instance|
	instance :=  ManySlotTestObject new.
	
	self assert: slotObject field = nil.
	self should: [self slot write: slotObject to: slotObject] raise: InvalidType.
	self slot write: instance to: slotObject.
	
	self assert: slotObject field = instance.
	self assert: (instance field includes: slotObject).
	
	self slot write: nil to: slotObject.
	self assert: slotObject field = nil.! !

TypedSlotTest subclass: #OppositeSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!OppositeSlotTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 14:31'!
isAbstract
	^ self == OppositeSlotTest! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/7/2011 12:11'!
childrenSlot
	^ layout resolveSlot: #children! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/7/2011 12:11'!
parentSlot
	^ layout resolveSlot: #parent! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:29'!
slotClass
	^ OppositeSlot! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 19:15'!
slotTestObjectClass
	^ OppositeSlotTestObject! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:07'!
testLayout
	super testLayout.
	self assertSlotAt: 4 named: #parent.
	self assertSlotAt: 5 named: #children.! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:56'!
testWriteChildrenOpposite
	|other|	
	other := self slotTestObjectClass new.
	self childrenSlot write: {slotObject} to: other.
	self assert: slotObject parent == other.
	self assert: (other children includes: slotObject).! !

!OppositeSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:56'!
testWriteParentOpposite
	|other|	
	other := self slotTestObjectClass new.
	self parentSlot write: other to: slotObject.
	self assert: slotObject parent == other.
	self assert: (other children includes: slotObject).
	! !

!TypedSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:46'!
slotClass
	^ TypedSlot! !

!TypedSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:43'!
slotTestObjectClass
	^ TypedSlotTestObject! !

!TypedSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:27'!
testRead
	self should: [slotObject field: 2] raise: InvalidType.
	self assert: slotObject field = nil.
	slotObject field: slotObject.
	self assert: (self slot read: slotObject) = slotObject.! !

!TypedSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 14:54'!
testWriteTo
	super testWriteTo.
	
	self should: [ self slot write: 1 to: slotObject] raise: InvalidType.! !

SlotTest subclass: #VirtualSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

VirtualSlotTest subclass: #AliasSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/7/2011 12:11'!
slot
	^ layout resolveSlot: #alias! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:18'!
slotClass
	^ AliasSlot! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:56'!
slotTestObjectClass
	^ AliasSlotTestObject! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:05'!
testAliasRead
	slotObject field: 1.
	self assert: slotObject field = 1.
	
	slotObject field: nil.
	self assert: slotObject field = nil.! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:34'!
testAliasWrite
	slotObject alias: 1.
	self assert: slotObject field2 = 1.
	
	slotObject alias: nil.
	self assert: slotObject field2 = nil.! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:37'!
testIndex
	self assert: self slot index = 4.! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:34'!
testRead
	slotObject field2: 2.
	self assert: (self slot read: slotObject) = 2.! !

!AliasSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:34'!
testWriteTo
	self assert: slotObject field2 isNil.
	self slot write: 2 to: slotObject.
	self assert: slotObject field2 = 2.! !

VirtualSlotTest subclass: #PropertySlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!PropertySlotTest methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:11'!
slot
	^ layout resolveSlot: #property! !

!PropertySlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 15:43'!
slotClass
	^ PropertySlot! !

!PropertySlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/22/2011 20:16'!
slotTestObjectClass
	^ PropertySlotTestObject! !

!PropertySlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 16:58'!
testIndex
	self assert: self slot index = 4.! !

!PropertySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:06'!
testLayout
	self assertSlotAt: 4 named: #property.! !

!PropertySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:59'!
testRead
	slotObject property: 2.
	self assert: slotObject property = 2.
	self assert: (self slot read: slotObject) = 2.! !

!PropertySlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:25'!
testWriteTo
	self assert: slotObject property = nil.
	self slot write: 1 to: slotObject.
	self assert: slotObject property = 1.! !

VirtualSlotTest subclass: #RGBSlotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:23'!
assertInitialValues
	self assert: slotObject red = 0.
	self assert: slotObject green = 0.
	self assert: slotObject blue = 0.! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:08'!
slotClass
	^ RGBSlot! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:08'!
slotTestObjectClass
	^ RGBSlotTestObject! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:08'!
testRGB! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:22'!
testRead
	self assert: (self slot read: slotObject) = 0.
	
	slotObject red: 16r12.
	slotObject green: 16r34.
	slotObject blue: 16r56.
	
	self assert: (self slot read: slotObject) = 16r123456.
	! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:24'!
testReadRGB
	self assert: slotObject rgb = 0.
	
	slotObject red: 16r12.
	slotObject green: 16r34.
	slotObject blue: 16r56.
	
	self assert: slotObject rgb = 16r123456.
	! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:25'!
testWriteRGB
	self assertInitialValues.
	
	slotObject rgb: 16r123456.
	
	self assert: slotObject red = 16r12.
	self assert: slotObject green = 16r34.
	self assert: slotObject blue = 16r56.! !

!RGBSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 16:25'!
testWriteTo
	self assertInitialValues.
	
	self slot write: 16r123456 to: slotObject.
	
	self assert: slotObject red = 16r12.
	self assert: slotObject green = 16r34.
	self assert: slotObject blue = 16r56.! !

!VirtualSlotTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:43'!
isAbstract
	^ self == VirtualSlotTest! !

!VirtualSlotTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:42'!
testSize
	self assert: self slot size = 0.! !

Object subclass: #MyFirstClass
	instanceVariableNames: 'x'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Traits-Test'!

!MyFirstClass methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/2/2011 21:18'!
test
	Transcript show: 'test'; cr.! !

MyFirstClass subclass: #MyFirstTest
	uses: TStatefulTest
	instanceVariableNames: 'd tfirst'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Traits-Test'!

MyFirstTest class
	uses: TStatefulTest classTrait
	instanceVariableNames: ''!

!MyFirstTest methodsFor: 'some messages' stamp: 'ToonVerwaest 4/2/2011 21:04'!
method2
	^ x + d! !

!MyFirstTest methodsFor: 'some messages' stamp: 'ToonVerwaest 4/4/2011 13:49'!
mtfirst
	^ tfirst! !

Object subclass: #NilTraitComposition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Traits'!

NilTraitComposition class
	instanceVariableNames: 'instance'!

NilTraitComposition class
	instanceVariableNames: 'instance'!

!NilTraitComposition class methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 23:10'!
instance
	^ instance ifNil: [ instance := self new ]! !

!NilTraitComposition methodsFor: 'layout' stamp: 'ToonVerwaest 3/31/2011 23:00'!
composeWithLayout: aLayout
	^ aLayout! !

!NilTraitComposition methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 21:02'!
copyTraitExpression
	" ^ self "! !

!Object methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/24/2011 14:50'!
ensureNilOrType: aClass
	self = nil
		ifTrue: [ ^ self ].
	(self isKindOf: aClass)
		ifFalse: [ (InvalidType has: self expected: aClass) signal].! !

!Object methodsFor: '*SlotExtras' stamp: 'CamilloBruni 3/23/2011 14:23'!
ensureType: aClass
	(self isKindOf: aClass)
		ifFalse: [ (InvalidType has: self expected: aClass) signal].! !

Object subclass: #SlotLayoutBuilder
	instanceVariableNames: 'slots layoutClass slotScope host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-LayoutBuilder'!

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:30'!
make: aBlock
	|builder|
	builder := self new.
	aBlock value: builder.
	^ builder build! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:02'!
make: aBlock layout: aLayoutClass
	^ self make: [ :builder|
		builder layout: aLayoutClass.
		aBlock value: builder.
	]! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:02'!
makeByte: aBlock
	^ self make: aBlock layout: ByteLayout! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:00'!
makeVariable: aBlock
	^ self make: aBlock layout: VariableLayout! !

!SlotLayoutBuilder class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:02'!
makeWord: aBlock
	^ self make: aBlock layout: WordLayout! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:21'!
addSlots: aCollection
	aCollection do: [ :slot|
		self slot: slot].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 16:43'!
atIndex: index ifAbsent: aBlock
	index = 0
		ifFalse: [ ^ slots at: index].
	^ aBlock value.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:06'!
build
	|layout|
	self checkPreconditions.
	self finalizeSlots.
	layout := self buildLayout.
	self ensureUniqueSlotNames.
	^ layout.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:48'!
buildLayout
	| layout |
	layout := layoutClass new.
	layout slotScope: self buildSlotScope.
	^ layout.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:47'!
buildSlotScope
	^ slotScope extend: slots asArray.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:05'!
checkPreconditions
	layoutClass ifNil: [ self error: 'No layout class specified' ].
	slotScope ifNil: [ self error: 'No slot scope specified' ].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:43'!
ensureUniqeParentSlotName: aSlot
	slotScope allSlotsDo: [:slot|
		slot name == aSlot name
			ifTrue: [
				SlotDuplicationConflict new 
					newSlot: aSlot;
					oldSlot: slot;
					signal]]! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:42'!
ensureUniqueSlotName: aSlot
	aSlot isVisible 
		ifFalse: [ ^ self].
	^ self ensureUniqueSlotName: aSlot startingAt: 1.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:42'!
ensureUniqueSlotName: aSlot startingAt: start
	|slot|
	self ensureUniqeParentSlotName: aSlot.
	start to: slots size do: [:index|
		slot := slots at: index.
		slot name == aSlot name
			ifTrue: [
				SlotDuplicationConflict new 
					newSlot: aSlot;
					oldSlot: slot;
					signal]]! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:40'!
ensureUniqueSlotNames
	slots withIndexDo: [ :slot  :index |
		self ensureUniqueSlotName: slot startingAt: index + 1].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:32'!
finalizeSlots
	slots do: [ :slot| 
		slot finalize: self].! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:31'!
findFirstSlot: aConditionBlock ifAbsent: aBlock
	slotScope allSlotsDo: [:slot|
			(aConditionBlock value: slot)
				ifTrue: [ ^ slot ]].
	^ self atIndex: (slots findFirst: aConditionBlock) ifAbsent: aBlock.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:32'!
findFirstSlotNamed: name
	^ self findFirstSlot: [:slot| slot name == name] 
			 ifAbsent: [ SlotNotFound signalForName: name]! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 14:31'!
findLastSlot: aConditionBlock ifAbsent: aBlock
	slotScope allSlotsReverseDo: [:slot|
			(aConditionBlock value: slot)
				ifTrue: [ ^ slot ]].
	^ self atIndex: (slots findLast: aConditionBlock) ifAbsent: aBlock.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:16'!
host 
	^ host! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:15'!
host: aClass 
	host := aClass! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:21'!
initialize
	slots := OrderedCollection new.
	layoutClass := PointerLayout.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 15:37'!
layout: aLayoutClass
	layoutClass := aLayoutClass.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:51'!
resolveSlot: slotOrSymbol
	(slotOrSymbol isKindOf: Slot)
		ifTrue: [ ^ slotOrSymbol ].
	^ self findFirstSlotNamed: slotOrSymbol! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:44'!
scope: aSlotScope
	slotScope := aSlotScope.! !

!SlotLayoutBuilder methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 16:10'!
slot: aSlot
	|newSlot|
	newSlot := aSlot asSlot.
	self ensureUniqueSlotName: newSlot.
	slots add: newSlot.
	^ aSlot.! !

Object subclass: #SlotObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Class'!

SlotObject subclass: #AbstractSlotTestObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!AbstractSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field1
	^ field1! !

!AbstractSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field1: aValue
	field1 := aValue! !

!AbstractSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field2
	^ field2! !

!AbstractSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field2: aValue
	field2 := aValue! !

!AbstractSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field3
	^ field3! !

!AbstractSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field3: aValue
	field3 := aValue! !

AbstractSlotTestObject subclass: #ActiveSlotTestObject
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!ActiveSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 3/25/2011 01:55'!
active
	^ active! !

!ActiveSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 3/24/2011 23:14'!
active: anObject
	active := anObject! !

!ActiveSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field
	^ active! !

!ActiveSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field: aValue
	active := aValue! !

AbstractSlotTestObject subclass: #AliasSlotTestObject
	instanceVariableNames: 'alias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!AliasSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:04'!
alias

	^ alias! !

!AliasSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 13:04'!
alias: anObject

	alias := anObject! !

!AliasSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field
	^ alias! !

!AliasSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field: aValue
	alias := aValue! !

AbstractSlotTestObject subclass: #BitSlotTestObject
	instanceVariableNames: 'bit1 bit2 bit3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!BitSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 19:02'!
bit1
	^ bit1! !

!BitSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 23:43'!
bit1: aBoolean
	bit1 := aBoolean! !

!BitSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:51'!
bit2

	^ bit2! !

!BitSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:51'!
bit2: aBoolean
 	bit2 := aBoolean! !

AbstractSlotTestObject subclass: #FloatSlotTestObject
	instanceVariableNames: 'float'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!FloatSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field
	^ float! !

!FloatSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field: aValue
	float := aValue! !

!FloatSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:44'!
float
	^ float! !

!FloatSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:44'!
float: anObject
	float := anObject! !

AbstractSlotTestObject subclass: #IntegerSlotTestObject
	instanceVariableNames: 'integer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!IntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:56'!
field
	^ integer! !

!IntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:57'!
field: aValue
	integer := aValue! !

!IntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:42'!
integer
	^ integer! !

!IntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:42'!
integer: aValue
	integer := aValue! !

AbstractSlotTestObject subclass: #LazySlotTestObject
	instanceVariableNames: 'lazy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!LazySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:57'!
field
	^ lazy! !

!LazySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:57'!
field: aValue
	lazy := aValue! !

!LazySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:57'!
lazy
	^ lazy! !

!LazySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:57'!
lazy: anObject
	lazy := anObject! !

AbstractSlotTestObject subclass: #ManySlotTestObject
	instanceVariableNames: 'many'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!ManySlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:57'!
field
	^ many! !

!ManySlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field: aValue
	many := aValue! !

!ManySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:57'!
many
	^ many! !

!ManySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:57'!
many: anObject
	many := anObject! !

AbstractSlotTestObject subclass: #NumberSlotTestObject
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!NumberSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field
	^ number! !

!NumberSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field: aValue
	number := aValue! !

!NumberSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:44'!
number
	^ number! !

!NumberSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:44'!
number: anObject
	number := anObject! !

AbstractSlotTestObject subclass: #OneSlotTestObject
	instanceVariableNames: 'one'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!OneSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field
	^ one! !

!OneSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field: aValue
	one := aValue! !

!OneSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:58'!
one
	^ one! !

!OneSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:58'!
one: anObject
	one := anObject! !

AbstractSlotTestObject subclass: #OppositeSlotTestObject
	instanceVariableNames: 'parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!OppositeSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 17:26'!
children
	^ children! !

!OppositeSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 17:26'!
children: aCollection
	children := aCollection! !

!OppositeSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:41'!
hasChild: aChild

	^ parent includes: aChild.! !

!OppositeSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 17:26'!
parent
	^ parent! !

!OppositeSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:53'!
parent: anObject

	parent := anObject! !

AbstractSlotTestObject subclass: #PositiveIntegerSlotTestObject
	instanceVariableNames: 'positiveInteger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!PositiveIntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field
	^ positiveInteger! !

!PositiveIntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field: aValue
	positiveInteger := aValue! !

!PositiveIntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:41'!
positiveInteger
	^ positiveInteger! !

!PositiveIntegerSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:41'!
positiveInteger: aValue
	positiveInteger := aValue.! !

AbstractSlotTestObject subclass: #PreconditionSlotTestObject
	instanceVariableNames: 'precondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!PreconditionSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:58'!
field
	^ precondition! !

!PreconditionSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 15:59'!
field: aValue
	precondition := aValue! !

!PreconditionSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:45'!
precondition
	^ precondition! !

!PreconditionSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:45'!
precondition: anObject
	precondition := anObject! !

AbstractSlotTestObject subclass: #PropertySlotTestObject
	instanceVariableNames: 'property'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!PropertySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 16:22'!
property

	^ property! !

!PropertySlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 16:21'!
property: anObject

	property := anObject! !

AbstractSlotTestObject subclass: #RGBSlotTestObject
	instanceVariableNames: 'rgb red green blue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 15:30'!
blue
	^ blue! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 15:30'!
blue: anObject
	blue := anObject! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:00'!
field
	^ rgb! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:00'!
field: aValue
	rgb := aValue! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 15:30'!
green
	^ green! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 15:30'!
green: anObject
	green := anObject! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 15:25'!
initialize
	super initialize.
	
	red := 0.
	green := 0.
	blue := 0.! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 15:30'!
red
	^ red! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 15:30'!
red: anObject
	red := anObject! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:46'!
rgb
	^ rgb! !

!RGBSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:46'!
rgb: aValue
	rgb := aValue! !

AbstractSlotTestObject subclass: #SingletonSlotTestObject
	instanceVariableNames: 'singleton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!SingletonSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:00'!
field
	^ singleton! !

!SingletonSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:00'!
field: aValue
	singleton := aValue! !

!SingletonSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 16:00'!
singleton
	^ singleton! !

!SingletonSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 16:00'!
singleton: anObject
	singleton := anObject! !

AbstractSlotTestObject subclass: #SlotTestObject
	instanceVariableNames: 'field'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:01'!
field
	^ field! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:01'!
field: aValue
	field := aValue! !

AbstractSlotTestObject subclass: #TypedSlotTestObject
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Test'!

!TypedSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:28'!
field
	^ type! !

!TypedSlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 16:01'!
field: aValue
	type := aValue! !

!TypedSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:42'!
type
	^ type! !

!TypedSlotTestObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 15:42'!
type: anObject
	type := anObject! !

SlotObject subclass: #ActiveField
	instanceVariableNames: 'value slot mySelf listeners'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot'!

!ActiveField class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:09'!
slot: aSlot self: anObject
	^ (self new)
		mySelf: anObject;
		slot: aSlot;
		yourself! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:29'!
= other
	^ value = other! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: value! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:41'!
for: anInstance notify: anObject
	|aBlockOrSlot|
	aBlockOrSlot := anObject.
		
	aBlockOrSlot isSymbol
		ifTrue: [	
			aBlockOrSlot := anInstance class layout 
									atName: aBlockOrSlot ifAbsent: [aBlockOrSlot]].
	
	(aBlockOrSlot isKindOf: Slot)
		ifTrue: [ 
			^ listeners at: anInstance 
			     		  put: [:val| aBlockOrSlot write: val to: anInstance]].
				
	aBlockOrSlot isSymbol
		ifTrue: [	
			(anInstance class lookupSelector: aBlockOrSlot)
				ifNotNilDo:[ :aMethod| aBlockOrSlot := aMethod]].
								
	aBlockOrSlot isCompiledMethod
		ifTrue: [
			^ listeners at: anInstance 
			     		  put: [:val| anInstance withArgs: {val} executeMethod: aBlockOrSlot]].
				
				
	listeners at: anInstance put: aBlockOrSlot.
		
	
	! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:07'!
initialize
	listeners := WeakKeyDictionary new.! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
mySelf
	^ mySelf! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
mySelf: anObject
	mySelf := anObject! !

!ActiveField methodsFor: 'accessing' stamp: 'CamilloBruni 3/24/2011 23:06'!
slot
	^ slot! !

!ActiveField methodsFor: 'accessing' stamp: 'CamilloBruni 3/24/2011 23:06'!
slot: anObject
	slot := anObject! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:06'!
value
	^ value! !

!ActiveField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 23:15'!
value: anObject 
	value := anObject.
	listeners do: [ :aBlock|
		aBlock value: value].
	^ anObject! !

SlotObject subclass: #SSlotObject
	instanceVariableNames: 'p p2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Class'!

!SSlotObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 22:05'!
p
	^ p! !

!SSlotObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 22:05'!
p2
	^ p2! !

!SSlotObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 22:05'!
p2: anObject
	p2 := anObject! !

!SSlotObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 22:05'!
p: anObject
	p := anObject! !

SlotObject subclass: #SlotModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

SlotModifier subclass: #AccessModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

AccessModifier subclass: #ReadOnlyModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

AccessModifier subclass: #WriteOnlyModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

SlotModifier subclass: #IdentityModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

SlotModifier subclass: #ImmutableModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

SlotModifier subclass: #PropertyModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

SlotModifier subclass: #VisibilityModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

VisibilityModifier subclass: #PrivateModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

VisibilityModifier subclass: #ProtectedModifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Slot-Modifier'!

!SlotObject class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/16/2011 19:47'!
basicNew
	|instance|
	self flag: 'questionable position of the slot initialization'.
	instance := super basicNew.
	self flag: 'workaround.. run the slot initializeation twice to properly initialize the instances...'.
	self layout ifNotNil: [ self layout initializeInstance: instance ].
	^ instance! !

!SlotObject class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 16:37'!
definition
	^ String streamContents: [ :aStream | self storeOn: aStream].! !

!SlotObject class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 16:04'!
layout
	^ layout! !

Object subclass: #SlotVirus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotExtras-Transformation'!

!SlotVirus commentStamp: 'CAmi 3/15/2011 15:47' prior: 0!
I am used to spread slot into an unaffected system. 

   SlotVirus spread.

Initializes default slots and layouts on all objects (note: so far this will break custom objects with custom slots)!

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:17'!
basicLayoutFor: aClass
	aClass isBits
		ifTrue: [
			aClass isBytes ifTrue: [ ^ aClass superclass layout extendByte ].
			 ^ aClass superclass layout extendWord ].
	
	aClass isWeak 
		ifTrue: [ ^ self basicWeakLayoutFor: aClass  ].
	
	aClass isVariable 
		ifTrue: [ ^ self basicVariableLayoutFor: aClass ].
	
	^ aClass superclass layout extend: (self layoutScopeFor: aClass).! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicLayoutScopeFor: aClass
	^ aClass superclass layout slotScope extend: (aClass instVarNames ifNil: [ #() ])! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicVariableLayoutFor: aClass
	^ aClass superclass layout extendVariable: (self layoutScopeFor: aClass)! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicWeakLayoutFor: aClass
	^ aClass superclass layout extendWeak: (self layoutScopeFor: aClass)! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:28'!
checkAllLayouts
	(SystemNavigation default allClasses sort: [:a :b| a name <= b name])
		do: [ :cls|
			self checkLayoutOfClass: cls.
			self checkLayoutOfClass: cls class.]! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:22'!
checkDuplicateClass: cls
	cls isMeta 
		ifTrue: [ ^ self ].
	(Smalltalk includesKey: cls name)
		ifFalse: [ ^ self].
	((Smalltalk at: cls name) == cls)
		ifFalse: [ cls becomeForward: (Smalltalk at: cls name)].! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:12'!
checkInheritedSlots: cls
	| mySlot |
	cls superclass 
		ifNil: [ ^ self ].
		
	(cls superclass layout size <= cls layout size)
		ifFalse: [
			self error: (cls name, ' does not inherit all slots from ', cls superclass name).
			^ self].
	
	cls superclass layout allSlots withIndexDo: [ :slot :index|
		mySlot := (cls layout slotAt: index).
		self haltIf: slot index ~= mySlot index.
		self haltIf: slot name ~= mySlot name].! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:11'!
checkLayout: aClass 
	(aClass withAllSubclasses sort: [:a :b| a name <= b name])
		do: [ :cls|
			self checkLayoutOfClass: cls.
			self checkLayoutOfClass: cls class.]! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 15:02'!
checkLayoutOfClass: cls
	self checkDuplicateClass: cls.
	self assert: cls layout isNil not.
	"self assert: cls format == cls layout format."
	cls layout checkSanity.
	cls layout hasSlots 
		ifFalse: [ ^ self].
		
	cls isMeta
		ifFalse: [ 
			(cls superclass subclasses includes: cls)
				ifFalse: [
					"self error: (cls name, ' is not properly registered as sublclass of ', cls superclass name)."
					self fixSuperclassSubclasses: cls]].
		
	self checkInheritedSlots: cls.
	
	self checkSlotsIndices: cls! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:14'!
checkSlotsIndices: cls
	cls layout allSlots withIndexDo: [ :slot :index|
		self assert: slot name isNil not.
		self flag: 'fix slot indexing..'
		"self assert: slot index = ((cls layout fixedSizeUpToIndex: index) + 1).
		slot index: ((cls layout fixedSizeUpToIndex: index) + 1)"]! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 3/31/2011 14:16'!
fixSuperclassSubclasses: cls
	|collection newSubclasses|
	cls superclass 
		ifNil: [ ^ self ].
	cls superclass addSubclass: cls.
	! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:31'!
installLayoutVariable
	(ClassDescription allInstVarNames includes: #layout) ifTrue: [ ^ self ].
	ClassDescription addInstVarNamed: #layout.! !

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/29/2012 20:36'!
installNewLayouts
	ProtoObject
		instVarNamed: #layout
		put: ((NilLayout instance extend: #()) host: ProtoObject).
		
"	self flag: 'I do not like PseudoContext'.
	PseudoContext
		instVarNamed: #layout
		put: ((NilLayout instance extend: #()) host: ProtoObject)."

	ProtoObject allSubclassesDo: [ :aSubclass |
		aSubclass
			instVarNamed: #layout
			put: (self newLayoutFor: aSubclass) ].
		
	SmallInteger
		instVarNamed: #layout
		put: (SmallIntegerLayout new).
		
	CompiledMethod
		instVarNamed: #layout
		put: (CompiledMethodLayout new).! !

!SlotVirus class methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 15:26'!
invalidClasses
	| result |
	result := OrderedCollection new.
	ProtoObject withAllSubclassesDo: [ :aClass |
		aClass format ~~ aClass layout format ifTrue: [ result add: aClass ]].
	^ result! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:42'!
layoutScopeFor: aClass
	^ self basicLayoutScopeFor: aClass! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:56'!
newLayoutFor: aClass

	|aLayout|
	
	aLayout := (self basicLayoutFor: aClass).
	aLayout := aClass traitComposition composeWithLayout: aLayout.
		
	"fill in the instvars without triggering any slots"
	^ aLayout
		instVarNamed: #host put: aClass;
		instVarNamed: #compactClassIndex put: aClass indexIfCompact;
		yourself! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 10/16/2011 19:41'!
refresh
	Slot recompileAll.
	AbstractLayout recompileAll.
	SlotObject recompileAll.
	SlotTest recompileAll.
	SlotModifier recompileAll.! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 3/28/2011 18:07'!
removeBrokenDoIts
	SystemNavigation default allClassesDo: [ :cls|
		cls methodDict removeKey: #DoItIn: ifAbsent: []].! !

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/29/2012 20:44'!
spread
	self installLayoutVariable.
	self installNewLayouts.
	
	SystemNavigation default allClasses 
		do: [ :cls|
			cls initializeLayout.
			cls class initializeLayout]
		displayingProgress:[:aClass| 'Processing ', aClass name].
	
	AbstractLayout withAllSubclassesDo: [ :s |
		s allInstances do: [ :aLayout |
			self flag: #todo. "Remove the next if moving initialization code to AbstractLayout class."
			aLayout host ifNotNilDo: [ :host |
				aLayout instVarNamed: #compactClassIndex put: host indexIfCompact ] ]].! !
